<?php
class lnk
{

    private $linkid;            // PostgreSQL link identifier
    private $db;                // PostgreSQL database
    private $host;              // PostgreSQL server host
    private $user;              // PostgreSQL user
    private $passwd;            // PostgreSQL password
    private $port;              // PostgreSQL port
    private $result;            // Query result
    private $querycount;        // Total queries executed
    private $table_inserted;    // Inserted Table


    /* Class constructor. Initializes the $host, $user, $passwd and $db fields. */
    function __construct($host = 'localhost', $db = 'routings', $user = 'postgres', $passwd = '1234', $port = 5432)
    {
            
        $this->host = ( isset($host) ) ? $host : 'localhost';
        $this->db = ( isset($db) ) ? $db : 'master-aimar';
        $this->user = ( isset($user) )? $user : 'user_trafico';
        $this->passwd = ( isset($passwd) ) ? $passwd : 'traf1c0Mar1t1m0';
        $this->port = ( isset($port) ) ? $port : 5432;

        $this->table_inserted = '';
    }


    /* Connects to the PostgreSQL Database */
    function connect()
    {
        try {
            $this->linkid = pg_connect("host=$this->host dbname=$this->db user=$this->user password=$this->passwd port=$this->port options='--client_encoding=UTF8 --application_name=routings'");
            if (! $this->linkid) {
                throw new Exception("Could not connect to PostgreSQL server. ");
            }
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }


    /* Execute database query. */
    function query($query)
    {

        if (!$this->linkid) {
            $this->connect();
        }

        try {
            $this->table_inserted = '';
            $this->result = pg_query($this->linkid, $query);

            if (! $this->result) {
                $msg = pg_last_error($this->linkid);
                throw new Exception("The database query failed: ".$msg);
            } else {
                if (stripos($query, 'INSERT INTO') === false) {
                    $this->table_inserted = '';
                } else {
                    $count = pg_affected_rows($this->result);
                    if ($count > 0) {
                        $this->table_inserted = trim(substr($query, 12, strpos($query, '(')-12));
                    }
                }
            }
        } catch (Exception $e) {
            echo $e->getMessage();
        }
        $this->querycount++;
        return $this->result;
    }


    /* Determine total rows affected by query. */
    function affectedRows()
    {
        $count = pg_affected_rows($this->linkid);
        return $count;
    }



    /* Determine total rows returned by query */
    function numRows()
    {
        $count = pg_num_rows($this->result);
        return $count;
    }



    /* Return query result row as an object. */
    function fetchObject()
    {
        $row = pg_fetch_object($this->result);
        return $row;
    }



    /* Return query result row as an indexed array. */
    function fetchRow()
    {
        $row = pg_fetch_row($this->result);
        return $row;
    }



    /* Return query result row as an associated array. */
    function fetchArray()
    {
        $row = pg_fetch_array($this->result, null, PGSQL_ASSOC);
        return $row;
    }


    /* Return total number of queries executed during
    lifetime of this object. Not required, but
    interesting nonetheless. */
    function numQueries()
    {
        return $this->querycount;
    }



    /*Function's transaction*/

    function begin()
    {
        if (!$this->linkid) {
            $this->connect();
        }
        $this->query('START TRANSACTION');
    }


    function commit()
    {
        $this->query('COMMIT');
    }


    function rollback()
    {
        $this->query('ROLLBACK');
    }


    function setsavepoint($savepointname)
    {
        $this->query("SAVEPOINT $savepointname");
    }


    function rollbacktosavepoint($savepointname)
    {
        $this->query("ROLLBACK TO SAVEPOINT $savepointname");
    }


    /*discontinued since version 8.2   ( select * from table returninig id_table ) */
    function last_insert_id($table = '')
    {
        $id=0;
        if ($table=='') {
            $table = $this->table_inserted;
        }
        if ($table<>'') {
            $cmd = "select a.attname as column
                            FROM pg_catalog.pg_attribute a
                            LEFT JOIN pg_catalog.pg_type t ON t.oid = a.atttypid
                            LEFT JOIN pg_catalog.pg_class c ON c.oid = a.attrelid
                            LEFT JOIN pg_catalog.pg_constraint cc ON cc.conrelid = c.oid AND cc.conkey[1] = a.attnum
                            WHERE c.relname = '$table' AND a.attnum > 0 AND t.oid = a.atttypid and cc.contype='p' ";
            try {
                $this->result = pg_query($this->linkid, $cmd);
                if (! $this->result) {
                    throw new Exception("The pg_catalog query failed.");
                } else {
                    $row = pg_fetch_array($this->result);
                    $column = $row['column'];

                    $cmd = "select currval(pg_get_serial_sequence('$table','$column')) as id ";

                    $this->result = pg_query($this->linkid, $cmd);
                    if (! $this->result) {
                        throw new Exception("The currval query failed.");
                    } else {
                        $row = pg_fetch_array($this->result);
                        $id = $row['id'];
                    }
                }
            } catch (Exception $e) {
                echo $e->getMessage();
            }
        }
        return $id;
    }
}
