﻿/*
user_trafico
traf1c0Mar1t1m0
*/


drop table if exists routings_errores;
drop table if exists routings_errores_trafico;
drop table if exists routings_errores_clasifica;





create table routings_errores_trafico( id_trafico serial,
										titulo varchar(30) not null default '',											
										constraint pk_error_clase primary key(id_trafico) );


insert into routings_errores_trafico(titulo) 
	values('Aéreo'),('Marítimo'),('Terrestre'),('Seguros'),('Aduana');




create table routings_errores_clasifica( id_error_clase serial,
											linea integer not null default 1,
											titulo varchar(30) not null default '',
											descripcion varchar(75) not null default '',
											activo boolean not null default true,
											unique (linea),
											constraint pk_error_clase2 primary key(id_error_clase) );


select id_error_clase, titulo from routings_errores_clasifica where activo=true order by linea;

insert into routings_errores_clasifica(linea,titulo) 
values(1,'Entrega Tardía'),(2,'Datos Incorrectos'),(3,'Diferencia en tarifas'),
		(4,'Contactos Malos o Inexistente'),(5,'Impresión en HBL'),(20,'Otros');





create table routings_errores(  id_error serial,
								id_routing integer not null,
								id_error_clase integer not null,
								id_usuario integer not null,
								id_trafico integer not null,								
								fecha timestamp not null default now(),
								activo boolean not null default true,
								observaciones text,
								constraint pk_error primary key(id_error),
								
								constraint fk_routing FOREIGN KEY (id_routing)
									REFERENCES routings (id_routing) MATCH SIMPLE
										ON UPDATE NO ACTION ON DELETE NO ACTION,

								constraint fk_routing_error FOREIGN KEY (id_error_clase)
									REFERENCES routings_errores_clasifica (id_error_clase) MATCH SIMPLE
										ON UPDATE NO ACTION ON DELETE NO ACTION,
																			
								constraint fk_usuario FOREIGN KEY (id_usuario)
									REFERENCES usuarios_empresas (id_usuario) MATCH SIMPLE
										ON UPDATE NO ACTION ON DELETE NO ACTION,

								constraint fk_trafico FOREIGN KEY (id_trafico)
									REFERENCES routings_errores_trafico (id_trafico) MATCH SIMPLE
										ON UPDATE NO ACTION ON DELETE NO ACTION
										);					


select * from routings_errores;
select * from routings_errores_clasifica;
select * from routings_errores_trafico;

/*
insert into routings_errores(id_routing, id_error_clase, id_usuario, id_trafico, observaciones)
	values(11401,1,33,1,'Prueba');

update routings_errores set id_trafico=900000 where id_error=1;

update routings_errores_trafico set color='#EEEEDD' where id_trafico=3
*/





